/*
==================================================================================
  Copyright (c) 2021 Samsung

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

   This source code is part of the near-RT RIC (RAN Intelligent Controller)
   platform project (RICP).
==================================================================================
*/
// Code generated by go-swagger; DO NOT EDIT.

package a1_mediator

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"
)

// A1ControllerCreateOrReplacePolicyInstanceAcceptedCode is the HTTP code returned for type A1ControllerCreateOrReplacePolicyInstanceAccepted
const A1ControllerCreateOrReplacePolicyInstanceAcceptedCode int = 202

/*A1ControllerCreateOrReplacePolicyInstanceAccepted Policy instance creation initiated


swagger:response a1ControllerCreateOrReplacePolicyInstanceAccepted
*/
type A1ControllerCreateOrReplacePolicyInstanceAccepted struct {
}

// NewA1ControllerCreateOrReplacePolicyInstanceAccepted creates A1ControllerCreateOrReplacePolicyInstanceAccepted with default headers values
func NewA1ControllerCreateOrReplacePolicyInstanceAccepted() *A1ControllerCreateOrReplacePolicyInstanceAccepted {

	return &A1ControllerCreateOrReplacePolicyInstanceAccepted{}
}

// WriteResponse to the client
func (o *A1ControllerCreateOrReplacePolicyInstanceAccepted) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(202)
}

// A1ControllerCreateOrReplacePolicyInstanceBadRequestCode is the HTTP code returned for type A1ControllerCreateOrReplacePolicyInstanceBadRequest
const A1ControllerCreateOrReplacePolicyInstanceBadRequestCode int = 400

/*A1ControllerCreateOrReplacePolicyInstanceBadRequest Bad PUT body for this policy instance


swagger:response a1ControllerCreateOrReplacePolicyInstanceBadRequest
*/
type A1ControllerCreateOrReplacePolicyInstanceBadRequest struct {
}

// NewA1ControllerCreateOrReplacePolicyInstanceBadRequest creates A1ControllerCreateOrReplacePolicyInstanceBadRequest with default headers values
func NewA1ControllerCreateOrReplacePolicyInstanceBadRequest() *A1ControllerCreateOrReplacePolicyInstanceBadRequest {

	return &A1ControllerCreateOrReplacePolicyInstanceBadRequest{}
}

// WriteResponse to the client
func (o *A1ControllerCreateOrReplacePolicyInstanceBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(400)
}

// A1ControllerCreateOrReplacePolicyInstanceNotFoundCode is the HTTP code returned for type A1ControllerCreateOrReplacePolicyInstanceNotFound
const A1ControllerCreateOrReplacePolicyInstanceNotFoundCode int = 404

/*A1ControllerCreateOrReplacePolicyInstanceNotFound There is no policy type with this policy_type_id


swagger:response a1ControllerCreateOrReplacePolicyInstanceNotFound
*/
type A1ControllerCreateOrReplacePolicyInstanceNotFound struct {
}

// NewA1ControllerCreateOrReplacePolicyInstanceNotFound creates A1ControllerCreateOrReplacePolicyInstanceNotFound with default headers values
func NewA1ControllerCreateOrReplacePolicyInstanceNotFound() *A1ControllerCreateOrReplacePolicyInstanceNotFound {

	return &A1ControllerCreateOrReplacePolicyInstanceNotFound{}
}

// WriteResponse to the client
func (o *A1ControllerCreateOrReplacePolicyInstanceNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(404)
}

// A1ControllerCreateOrReplacePolicyInstanceServiceUnavailableCode is the HTTP code returned for type A1ControllerCreateOrReplacePolicyInstanceServiceUnavailable
const A1ControllerCreateOrReplacePolicyInstanceServiceUnavailableCode int = 503

/*A1ControllerCreateOrReplacePolicyInstanceServiceUnavailable Potentially transient backend database error. Client should attempt to retry later.

swagger:response a1ControllerCreateOrReplacePolicyInstanceServiceUnavailable
*/
type A1ControllerCreateOrReplacePolicyInstanceServiceUnavailable struct {
}

// NewA1ControllerCreateOrReplacePolicyInstanceServiceUnavailable creates A1ControllerCreateOrReplacePolicyInstanceServiceUnavailable with default headers values
func NewA1ControllerCreateOrReplacePolicyInstanceServiceUnavailable() *A1ControllerCreateOrReplacePolicyInstanceServiceUnavailable {

	return &A1ControllerCreateOrReplacePolicyInstanceServiceUnavailable{}
}

// WriteResponse to the client
func (o *A1ControllerCreateOrReplacePolicyInstanceServiceUnavailable) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(503)
}
